require "facebook"

local appId = "352852401492555"
facebook:setAppId(appId);

local loggedIn = false
local userId
local profilePic
	
local function initText()

end
initText()

-------------------- File Functions --------------------
--to check if file exists
function file_exists(name)
   local f=io.open(name,"r")
   if f~=nil then io.close(f) return true else return false end
end
 
--to delete a file
function file_delete(name)
	if file_exists(name) then
		os.remove(name)
	end
end

-------------------- Facebook --------------------
-- Login
facebook:addEventListener(Event.LOGIN_COMPLETE, function()
	print("login successful")
end)
-- Logout
facebook:addEventListener(Event.LOGOUT_COMPLETE, function()
	print("logged out")
end)
-- Request complete
facebook:addEventListener(Event.REQUEST_COMPLETE, function(e)
	local data = Json.Decode(e.response)
	--for i=1, #data["data"] do
	userId = data.id
	print("requesting image: "..userId)
	--end
	fbPhotoQueue = {}
	table.insert(fbPhotoQueue, userId)
	fbProcessPhoto()
end)
-- Request error
facebook:addEventListener(Event.REQUEST_ERROR, function(e)
	print("request error:", e.type, e.error)
end)


-------------------- Process Photo Queue --------------------
-- to process photo queue
function fbProcessPhoto()
	--if there is something in queue
	if #fbPhotoQueue > 0 then
		--get id
		local id = table.remove(fbPhotoQueue)
		--construct url
		local url = "https://graph.facebook.com/"..id.."/picture?type=square"
		--make UrlLoader call
		local loader = UrlLoader.new(url)
		loader:addEventListener(Event.COMPLETE,function(event)
			print("complete", id)
			
			-- try to save it in file as png
			local out = io.open("|D|fb"..id..".png", "wb")
			out:write(event.data)
			out:close()
			-- resave it as png, because image might have been jpeg
			--but media plugin will automatically convert it to png
			-- pcall because it might be other unsupported format
			pcall(function()
				local media = Media.new("|D|fb"..id..".png")
				media:save()
				media = nil
			end)
		end)
		-- we can ignore errors photos and try them again on next sync
		loader:addEventListener(Event.ERROR,function()
			print("error",id)
		end)
		--call to process next photo
		fbProcessPhoto()		
	end
end

-------------------- Load Facebook Photo --------------------
function loadFBphoto(id)
	local texture
	local file="|D|fb"..id..".png"
	-- if picture exists
	if file_exists(file) then
		print("loading "..file)
		local success
		success,texture=pcall(Texture.new,file,true)
		-- if I was able to load it (has correct format)
		if not success then
			texture = nil
			print("error loading "..file)
		end
	else
		print("File "..file.." does not exist")
	end
	-- if no texture, take default pic
	if not texture then
		texture = Texture.new("picture.png", true)
	end
	return texture
end

-------------------- Load Facebook Photo without pcall --------------------
function loadFBphoto2(id)
	local texture
	local file="|D|fb"..id..".png"
	-- if picture exists
	if file_exists(file) then
		print("loading "..file.." without pcall")
		-- loading the file without pcall shows an "Image format not supported" error on the Output
		texture = Texture.new(file, true)
	else
		print("File "..file.." does not exist")
	end
	return texture
end

-------------------- Login --------------------
-- Login text
local loginText = TextField.new(nil, "Login")
loginText:setScale(3)
loginText:setPosition(10, 100)
stage:addChild(loginText)
-- Event listener
function facebookLogin(frame, event)
	if frame:hitTestPoint(event.touch.x, event.touch.y) then
		if not loggedIn then
			facebook:authorize({"public_profile","user_friends","email"})
			loggedIn = true
		end
	end
end
loginText:addEventListener(Event.TOUCHES_BEGIN, facebookLogin, loginText)

-------------------- Logout --------------------
-- Logout text
local logoutText = TextField.new(nil, "Logout")
logoutText:setScale(3)
logoutText:setPosition(10, 200)
stage:addChild(logoutText)
-- Event Listener
function facebookLogout(frame, event)
	if frame:hitTestPoint(event.touch.x, event.touch.y) then
		if loggedIn then
			facebook:logout()
			loggedIn = false
		end
	end
end
logoutText:addEventListener(Event.TOUCHES_BEGIN, facebookLogout, logoutText)

-------------------- Facebook Request --------------------
-- Request text
local fbRequestText = TextField.new(nil, "Graph request")
fbRequestText:setScale(3)
fbRequestText:setPosition(10, 300)
stage:addChild(fbRequestText)
function fbRequest(frame, event)
	if frame:hitTestPoint(event.touch.x, event.touch.y) then
		if loggedIn then
			facebook:graphRequest("me")
		else
			print("Not logged in")
		end
	end
end
fbRequestText:addEventListener(Event.TOUCHES_BEGIN, fbRequest, fbRequestText)

-------------------- Load photo --------------------
-- Load fb profile picture
local loadPhotoText = TextField.new(nil, "Load photo")
loadPhotoText:setScale(3)
loadPhotoText:setPosition(10, 400)
stage:addChild(loadPhotoText)
function loadPicture(frame, event)
	if frame:hitTestPoint(event.touch.x, event.touch.y) then
		if loggedIn then
			local tx = loadFBphoto(userId)
			showPicture(tx)
		else
			print("Not logged in")
		end
	end
end
loadPhotoText:addEventListener(Event.TOUCHES_BEGIN, loadPicture, loadPhotoText)

-- Load fb profile picture
local loadPhotoText2 = TextField.new(nil, "Load photo without pcall")
loadPhotoText2:setScale(3)
loadPhotoText2:setPosition(10, 500)
stage:addChild(loadPhotoText2)
function loadPicture2(frame, event)
	if frame:hitTestPoint(event.touch.x, event.touch.y) then
		if loggedIn then
			local tx = loadFBphoto2(userId)
			showPicture(tx)
		else
			print("Not logged in")
		end
	end
end
loadPhotoText2:addEventListener(Event.TOUCHES_BEGIN, loadPicture2, loadPhotoText2)

function showPicture(txtr)
	profilePic = Bitmap.new(txtr)
	profilePic:setPosition(250, 75)
	stage:addChild(profilePic)
end